package com.programmersnotes;


import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.cfg.Configuration;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.UUID;

@Path("/h2")
public class H2Controller {

    @Produces("text/plain")
    @Path("/visit")
    @GET
    public String getVisit() throws Exception {
        Session session = new Configuration().configure().buildSessionFactory().openSession();
        session.beginTransaction();
        DateTimeFormatter dtf = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        LocalDateTime now = LocalDateTime.now();
        VisitorEntity visitor = new VisitorEntity(UUID.randomUUID().toString(), dtf.format(now));
        session.save(visitor);
        session.getTransaction().commit();

        Query query = session.createQuery("select count(*) from VisitorEntity");
        Long count = (Long) query.uniqueResult();
        session.close();

        return "Total visits: " + count;
    }
}
